package com.rube;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.utils.Array;

/**
 * Created by Alan on 2017/4/10.
 */
public class BodyData {
    String name;
    int type; // 0 static, 1 kinematic, 2 dynamic
    float gravityScale;
    float angle;
    float angularDamping;
    float angularVelocity;
    float linearDamping;
    float massDataI;
    final Vector2 linearVelocity = new Vector2();
    final Vector2 position = new Vector2();
    boolean awake;
    boolean bullet;
    boolean fixedRotation;
    Array<FixtureData> fixtures = new Array<FixtureData>();
    CustomProperties properties = null;

    void appendFixture(FixtureData fixtureData) {
        fixtures.add(fixtureData);
    }

    public void setProperties(CustomProperties properties) {
        this.properties = properties;
    }

    public String getName() {
        return name;
    }

    public int getType() {
        return type;
    }

    public float getGravityScale() {
        return gravityScale;
    }

    public float getMassDataI() {
        return massDataI;
    }

    public float getAngle() {
        return angle;
    }

    public float getAngularDamping() {
        return angularDamping;
    }

    public float getAngularVelocity() {
        return angularVelocity;
    }

    public float getLinearDamping() {
        return linearDamping;
    }

    public Vector2 getLinearVelocity() {
        return linearVelocity;
    }

    public Vector2 getPosition() {
        return position;
    }

    public boolean isAwake() {
        return awake;
    }

    public boolean isBullet() {
        return bullet;
    }

    public boolean isFixedRotation() {
        return fixedRotation;
    }

    public Array<FixtureData> getFixtures() {
        return fixtures;
    }

    public CustomProperties getProperties() {
        return properties;
    }

}
