package com.rube;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.utils.ArrayMap;

/**
 * Created by Alan on 2017/4/10.
 */
public class CustomProperties {
    ArrayMap<String, Object> prop = new ArrayMap<>();

    public CustomProperties put(String name, String val) {
        prop.put(name, val);
        return this;
    }
    public CustomProperties put(String name, int val) {
        prop.put(name, val);
        return this;
    }
    public CustomProperties put(String name, float val) {
        prop.put(name, val);
        return this;
    }
    public CustomProperties put(String name, Vector2 val) {
        prop.put(name, new Vector2(val));
        return this;
    }
    public CustomProperties put(String name, boolean val) {
        prop.put(name, val);
        return this;
    }
    public <T> T get(String name) {
        return (T)prop.get(name);
    }
    public <T> T get(String name, Class<T> clz) {
        Object o = prop.get(name);
        if (o.getClass().isAssignableFrom(clz)) {
            return (T)o;
        }
        throw new ClassCastException(o.getClass()+" cast to "+clz+" failed");
    }

    public static String getString(CustomProperties properties, String name, String defVal) {
        if (properties==null) {
            return defVal;
        }
        String s = properties.get(name, String.class);
        return s==null ? defVal : s;
    }
    public static Integer getInt(CustomProperties properties, String name, Integer defVal) {
        if (properties==null) {
            return defVal;
        }
        Integer s = properties.get(name, Integer.class);
        return s==null ? defVal : s;
    }
    public static Float getInt(CustomProperties properties, String name, Float defVal) {
        if (properties==null) {
            return defVal;
        }
        Float s = properties.get(name, Float.class);
        return s==null ? defVal : s;
    }
    public static Boolean getInt(CustomProperties properties, String name, Boolean defVal) {
        if (properties==null) {
            return defVal;
        }
        Boolean s = properties.get(name, Boolean.class);
        return s==null ? defVal : s;
    }

    public ArrayMap<String, Object> getProp() {
        return prop;
    }
}
