package com.rube;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Vector2;

/**
 * Created by Alan on 2017/4/10.
 */
public class ImageData implements ImageInterface, Drawer.ImageVertex {
    String name;
    String file;
    String filename; // file name without path and extension
    float centerX;
    float centerY;
    float scale;
    float angle;
    float opacity;
    int bodyIndex;
    float []cornerX;
    float []cornerY;
    boolean flipX;
    Color color;
    CustomProperties properties;
//    public Body body = null;
    public String getName() {
        return name;
    }
    // full path filename with extension
    public String getFile() {
        return file;
    }
    public String getFilename() {
        return filename;
    }
    public float getCenterX() {
        return centerX;
    }
    public float getCenterY() {
        return centerY  ;
    }
    public Vector2 getCenter(Vector2 out) {
        return out.set(centerX, centerY);
    }
    public float getScale() {
        return scale;
    }
    public float getOpacity() {
        return opacity;
    }
    public float getAngle() {
        return angle;
    }
    public float[] getCornerX() {
        return cornerX;
    }
    public float[] getCornerY() {
        return cornerY;
    }
    public int getBodyIndex() {
        return bodyIndex;
    }
    public boolean getFlipX() {
        return flipX;
    }

    public void setScale(float scale) {
        this.scale = scale;
    }

    public TextureRegion reigon;
    public String name() {
        return getFilename();
    }
    void cacheFileName() {
        filename = getFileName(file);
    }
    public static String getFileName(String file) {
        if (file==null) return null;
        int slash_index = file.lastIndexOf('/');
        int dot_index = file.lastIndexOf('.');
        if (slash_index<0) {
            slash_index = 0;
        }else {
            slash_index++;
        }
        if (dot_index<0) dot_index = file.length();

        return file.substring(slash_index, dot_index);
    }

    public void setProperties(CustomProperties properties) {
        this.properties = properties;
    }

    public static void main(String[] args) {
        for (int i=0; i<256; i++) {
            float a = i/255f;
            int x = (int)Math.round(a*255);
            if (i != x) {
                System.out.println("not equal when i="+i);
            }
        }
    }

    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public void setCornerX(float[] cornerX) {
        this.cornerX = cornerX;
    }

    public void setCornerY(float[] cornerY) {
        this.cornerY = cornerY;
    }

    public CustomProperties getProperties() {
        return properties;
    }


    public ImageData clone(){
        ImageData imageData = new ImageData();
        imageData.name = this.name;
        imageData.file = this.file;
        imageData.opacity = this.opacity;
        imageData.scale = this.scale;
        imageData.angle = this.angle;
        imageData.bodyIndex = this.bodyIndex;
        imageData.flipX = this.flipX;
        imageData.centerX = this.centerX;
        imageData.centerY = this.centerY;
        imageData.cornerX = this.cornerX;
        imageData.cornerY = this.cornerY;
        CustomProperties temp = new CustomProperties();
        temp.getProp().putAll(properties.getProp());
        imageData.properties = temp;
        imageData.filename = this.filename;
        return imageData;

    }
}
