package com.rube;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.graphics.Texture.TextureFilter;

/**
 * Created by lilexiang on 17-11-9.
 */
public class ImageUtils {
    ImageData data;
    TextureRegion region;
    protected Body body;
    protected boolean hasRegion = false;
    protected boolean visiable = true;
    boolean needOutline;
    private Color color = Color.WHITE;

    public boolean isHasRegion() {
        return hasRegion;
    }

    public void setVisiable(boolean visiable) {
        this.visiable = visiable;
    }

    int imageIndex;
    Vector2 position = new Vector2();

    public void setColor(Color color) {
        this.color = color;
    }

    public ImageUtils(Body body, ImageData data) {
        this.body = body;
        this.data = data;
        if (data.getProperties().get("Index") == null) {
            imageIndex = 0;
        }else{
            imageIndex =  data.getProperties().get("Index", Integer.class);
        }
        if(body!=null) {
            position.set(body.getPosition());
        }

    }

    public ImageData getData() {
        return data;
    }

    public void setNeedOutline(boolean needOutline) {
        this.needOutline = needOutline;
    }

    public void draw(Drawer drawer, Batch batch) {
        if(!visiable) return;
        if (body != null) {
            if(body.isAwake()){
                position.set(body.getPosition());
            }
        }
        batch.setColor(color);
        drawer.draw(batch, body, data, region,position.x,position.y);
    }

    public TextureRegion getRegion() {
        return region;
    }

    public String getName(){
        return data.getFilename();
    }

    public void setRegion(TextureRegion region) {
        this.region = region;
    }

    public Body getBody() {
        return body;
    }

    public int getImageIndex() {
        return imageIndex;
    }




}
