package com.rube;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.utils.ArrayMap;

/**
 * Created by Alan on 2017/4/10.
 */
public class JointData {
    String name="";
    String type="";
    Vector2 anchorA = new Vector2();
    Vector2 anchorB = new Vector2();
    int bodyA = -1;
    int bodyB = -1;
    ArrayMap<String, Float> float_map = new ArrayMap<String, Float>();
    ArrayMap<String, Boolean> bool_map = new ArrayMap<String, Boolean>();
    Vector2 localAxisA = null;
    CustomProperties properties = null;

    void add(String key, boolean bool) {
        bool_map.put(key, bool);
    }
    void add(String key, float v) {
        float_map.put(key, v);
    }
    void setProperties(CustomProperties properties) {
        this.properties = properties;
    }
    public CustomProperties getProperties() {
        return this.properties;
    }
    void setLocalAxisA(Vector2 localAxisA) {
        if (this.localAxisA==null)
            this.localAxisA = new Vector2();
        this.localAxisA.set(localAxisA);
    }
    public Vector2 getLocalAxisA() {
        return localAxisA;
    }

    public String getName() {
        return name;
    }

    public String getType() {
        return type;
    }

    public Vector2 getAnchorA() {
        return anchorA;
    }

    public Vector2 getAnchorB() {
        return anchorB;
    }
    public int BodyAindex() {return bodyA;}
    public int BodyBindex() {return bodyB;}
    public boolean is(String tag) {
        Boolean b = bool_map.get(tag);
        return b!=null && b;
    }
    public float getFloat(String tag) {
        return getFloat(tag, 0);
    }
    public float getFloat(String tag, float def) {
        Float f = float_map.get(tag);
        return (f==null || Float.isNaN(f)) ? def : f;
    }
}
