package com.rube;

import com.badlogic.gdx.math.Vector2;

/**
 * Created by Alan on 2017/4/11.
 */
public class ShapeData {

    public static class Circle extends ShapeData {
        public final Vector2 center = new Vector2();
        public float radius;
    }
    public static class Polygon extends ShapeData {
        float []vertices_x;
        float []vertices_y;
        public float [] getVerticesX() {
            return vertices_x;
        }
        public float [] getVerticesY() {
            return vertices_y;
        }
    }
    public static class Chain extends ShapeData {
        float []vertices_x;
        float []vertices_y;
        Vector2 nextVertex;
        Vector2 prevVertex;

        void setNextVertex(Vector2 nextVertex) {
            if (this.nextVertex==null)
                this.nextVertex = new Vector2();
            this.nextVertex.set(nextVertex);
        }

        void setPrevVertex(Vector2 prevVertex) {
            if (this.prevVertex==null)
                this.prevVertex = new Vector2();
            this.prevVertex.set(prevVertex);
        }
        public boolean hasNextVertex() {
            return this.nextVertex != null;
        }
        public boolean hasPrevVertex() {
            return this.prevVertex != null;
        }

        public Vector2 getNextVertex() {
            return nextVertex;
        }

        public Vector2 getPrevVertex() {
            return prevVertex;
        }
        public float [] getVerticesX() {
            return vertices_x;
        }
        public float [] getVerticesY() {
            return vertices_y;
        }
    }
}
