package com.rube;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.utils.Array;

/**
 * Created by Alan on 2017/4/10.
 */
public class WorldData {
    public final Vector2 gravity = new Vector2();
    public boolean allowSleep;
    public boolean autoClearForces;
    public int positionIterations;
    public int velocityIterations;

    Array<BodyData> bodyData = new Array<BodyData>();
    Array<JointData> jointData = new Array<JointData>();
    Array<ImageData> imageData = new Array<ImageData>();
    CustomProperties properties;

    public Array<BodyData> getBodyList() {
        return bodyData;
    }
    public Array<JointData> getJointList() {
        return jointData;
    }
    public Array<ImageData> getImageList() {
        return imageData;
    }
    public CustomProperties getProperties() {
        return properties;
    }

    public void setAllowSleep(boolean allowSleep) {
        this.allowSleep = allowSleep;
    }

    public void setAutoClearForces(boolean autoClearForces) {
        this.autoClearForces = autoClearForces;
    }


    public Vector2 getGravity() {
        return gravity;
    }

    public boolean isAllowSleep() {
        return allowSleep;
    }

    public boolean isAutoClearForces() {
        return autoClearForces;
    }

    public int getPositionIterations() {
        return positionIterations;
    }

    public void setPositionIterations(int positionIterations) {
        this.positionIterations = positionIterations;
    }

    public int getVelocityIterations() {
        return velocityIterations;
    }

    public void setVelocityIterations(int velocityIterations) {
        this.velocityIterations = velocityIterations;
    }

    public Array<BodyData> getBodyData() {
        return bodyData;
    }

    public void setBodyData(Array<BodyData> bodyData) {
        this.bodyData = bodyData;
    }

    public Array<JointData> getJointData() {
        return jointData;
    }

    public void setJointData(Array<JointData> jointData) {
        this.jointData = jointData;
    }

    public Array<ImageData> getImageData() {
        return imageData;
    }

    public void setImageData(Array<ImageData> imageData) {
        this.imageData = imageData;
    }

    WorldData appendBody(BodyData bodyData) {
        this.bodyData.add(bodyData);
        return this;
    }
    WorldData appendJoint(JointData jointData) {
        this.jointData.add(jointData);
        return this;
    }
    WorldData appendImage(ImageData imageData) {
        this.imageData.add(imageData);
        return this;
    }
    void setProperties(CustomProperties properties) {
        this.properties = properties;
    }


}
