package com.zyb.loveball;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.zyb.loveball.assets.Assets;

public class CircleLayer extends Actor {
    private NinePatch testPatch;
    private boolean open = false;
    float distance = 960;
    private float stateTime;
    private float outTime;

    public CircleLayer(float time) {
        this.outTime = time;
        setTouchable(Touchable.disabled);
        testPatch = new NinePatch(Assets.instance.ui.findRegion("circle_black"), 4, 4, 4, 4);
        testPatch.setLeftWidth(500);
        testPatch.setRightWidth(500);
        testPatch.setTopHeight(1000);
        testPatch.setBottomHeight(1000);
        testPatch.setMiddleHeight(15);
        testPatch.setMiddleWidth(15);
    }

    public void open(float x, float y) {
        if (x > 480 || x < 0) {
            x = 240;
        }
        if (y < 0 || y > 800) {
            y = 400;
        }
        open = true;
        this.x = x;
        this.y = y;
        distance = Math.max(y, 960 - y);
        offset = 50/outTime * distance / 960;
    }

    float offset = 40;

    @Override
    public void act(float delta) {
        super.act(delta);
        stateTime += delta;
        if (distance < -200 || stateTime > 5) {
            open = false;
            remove();
        }
        if (open) {
            testPatch.setMiddleWidth(testPatch.getMiddleWidth() + offset);
            testPatch.setMiddleHeight(testPatch.getMiddleHeight() + offset);
            testPatch.setBottomHeight(testPatch.getBottomHeight() - offset / 2);
            testPatch.setTopHeight(testPatch.getTopHeight() - offset / 2);
            testPatch.setLeftWidth(testPatch.getLeftWidth() - offset / 2);
            testPatch.setRightWidth(testPatch.getRightWidth() - offset / 2);
        }
        distance -= offset / 2;
        originX = testPatch.getTotalWidth() / 2;
        originY = testPatch.getTotalHeight() / 2;

    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        batch.setColor(1, 1, 1, 1);
        testPatch.draw(batch, x - originX, y - originY, originX, originY, testPatch.getTotalWidth(), testPatch.getTotalHeight(), 1, 1, 0);
    }

    public interface LayerListener {
        public void end();
    }


}
