package com.zyb.loveball;

import com.zyb.loveball.assets.*;
import com.zyb.loveball.constants.Constant;
import com.zyb.loveball.objects.Pen;
import com.zyb.loveball.objects.Zombie;
import com.zyb.loveball.utils.FlurryUtils;

public class GameInfo {
    public static int id = -1;
    public static int chapter = -1;
    private static int chapterId;
    public static int levelId;
    public static LevelData levelData;
    public static int life;
    public static boolean challenge;
    public static int star = 3;
    public static int failureTimes;
    public static boolean hint;
    public static boolean course;

    public static void init() {
        reset();
        id = Configuration.settingData.getLastLevelInt();
        chapter = Configuration.settingData.getLastChapterInt();
    }

    public static void reset(){
        failureTimes = 0;
        hint = false;
    }

    public static void challenge(int challengeId) {
        challenge = true;
        chapter = challengeId;
        id = 1;
        life = 5;
        Zombie.outDie = true;
        if (challengeId == 1) {
            Pen.PenConfig.ink_off_write = false;
        }else if(challengeId == 2){
            Zombie.outDie = false;
        }else if(challengeId == 3){
            Pen.PenConfig.ink_off_write = true;
            Pen.PenConfig.max_write_times = 1;
        }
    }

    public static void normal() {
        challenge = false;
        id = Configuration.settingData.getLastLevelInt();
        chapter = Configuration.settingData.getLastChapterInt();
        life = 1;
        Pen.PenConfig.ink_off_write = true;
        Pen.PenConfig.max_write_times = Integer.MAX_VALUE;
        Zombie.outDie = true;
    }

    public static void start() {
        course = isCourseLevel();
        if(challenge){
            chapterId = chapter+10000;
        }else{
            chapterId = chapter;
        }
        levelId = Assets.instance.chaptersData.get(chapterId).getLevelId(id);
        levelData = Assets.instance.levelsData.get(levelId);
        if (!challenge) {
            Configuration.settingData.setLastLevelInt(chapter,id);
        }
        star = 3;
        FlurryUtils.level_Start(chapter,id);
    }

    public static void nextLevel() {
        id++;
        if (id > 10) {
            id = 1;
            chapter++;
            if (chapter == 31) {
                chapter = 1;
            }
        }
    }

    public static void preLevel(){
        id--;
        if (id < 1) {
            id = 10;
            chapter--;
            if (chapter <1) {
                chapter = 1;
            }
        }
    }

    private static boolean isCourseLevel(){
        if(challenge) return false;
        boolean temp = false;
        for(int i = 0; i <= Constant.hintLineHandArray.length-2; i += 2) {
            if (GameInfo.chapter == Constant.hintLineHandArray[i]
                    && GameInfo.id == Constant.hintLineHandArray[i + 1]) {
                temp = true;
            }
        }
        return temp;
    }


}
