package com.zyb.loveball;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;

public class PaintController extends Actor {
    PaintControllerListener listener;

    public PaintController(){
        setSize(480,1000);
        addListener(new ClickListener(){
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                if (pointer >0) return false;
                if(listener!=null){
                    listener.touchDown(x,y);
                }
                return super.touchDown(event, x, y, pointer, button);
            }

            @Override
            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
                super.touchUp(event, x, y, pointer, button);
                if (pointer >0) return;
                if(listener!=null){
                    listener.touchUp(x,y);
                }
            }

            @Override
            public void touchDragged(InputEvent event, float x, float y, int pointer) {
                super.touchDragged(event, x, y, pointer);
                if (pointer >0) return;
                if(listener!=null){
                    listener.touchDragged(x,y);
                }
            }
        });
    }

    public void setListener(PaintControllerListener listener) {
        this.listener = listener;
    }

    public interface PaintControllerListener{
        public void touchDown(float x,float y);
        public void touchDragged(float x,float y);
        public void touchUp(float x,float y);
    }
}
