package com.zyb.loveball;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.PolygonSpriteBatch;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.objects.MagnifierUtil;

public class UIPanel {
    Group root;
    private Label debugLabel;
    protected GameScreen screen;
    GamePanel gamePanel;
    MagnifierUtil magnifierUtil;


    public UIPanel(Group scene, GameScreen screen) {
        this.screen = screen;
        this.gamePanel = screen.gamePanel;
        Actor temp = scene.findActor("normal");
        temp.setTouchable(Touchable.childrenOnly);
        temp.setVisible(false);
        temp = scene.findActor("challenge");
        temp.setTouchable(Touchable.childrenOnly);
        temp.setVisible(false);
        if (Configuration.debug)
            initDebug();
    }


    public void initAnimation() {
    }


    public void showHand(boolean show) {

    }

    public void countdown(boolean show, int time) {

    }

    public void setGamePanel(GamePanel gamePanel) {
        this.gamePanel = gamePanel;
        magnifierUtil = new MagnifierUtil(GameInfo.levelData.getMagnifier(), gamePanel);
        if(!Configuration.poor) {
            ((Group) root.findActor("bottom")).addActor(magnifierUtil);
        }
    }

    protected void initButtons() {
        initAnimation();
    }

    private void initDebug() {
        Label.LabelStyle style = new Label.LabelStyle();
        style.font = Assets.instance.fonts[0];
        style.fontColor = new Color(0, 0, 1, 1);
        debugLabel = new Label("FPS:" + Gdx.graphics.getFramesPerSecond(), style) {
            @Override
            public void act(float delta) {
                super.act(delta);
                float hintLength = 0;
                if (gamePanel.getPaintPanel().hint != null) {
                    hintLength = gamePanel.getPaintPanel().hint.getHintLength();
                }
                debugLabel.setText("FPS:    " + Gdx.graphics.getFramesPerSecond()
                        + "\n Render Calls:  " + ((PolygonSpriteBatch) HelloZombieGame.getBatch()).renderCalls
                        + "\n Hint Length:  " + hintLength
                        + "\n neiCunJava:  " + Gdx.app.getJavaHeap()
                        + "   neiCunNative:  " + Gdx.app.getNativeHeap());
            }
        };
        debugLabel.setFontScale(0.3F, 0.3F);
        screen.getScene().addActor(debugLabel);
    }

    public void showSkip(boolean show) {
    }


    public void screenShot() {
    }


    public void update() {

    }

    public void success() {

    }

    public void updateWorldPosition(Vector2 position) {
        if (Configuration.poor) return;
        magnifierUtil.update(position);
    }

    public void magnifier(boolean magnifier) {
        if (Configuration.poor) return;
        magnifierUtil.setMagnifier(magnifier);
    }

    public Group getRoot() {
        return root;
    }

    public void failure() {

    }

    public void end(){

    }
}
