package com.zyb.loveball;

import com.badlogic.gdx.physics.box2d.*;

public class WorldContactHandler implements ContactListener {
    @Override
    public void beginContact(Contact contact) {
        Fixture fixtureA = contact.getFixtureA();
        Fixture fixtureB = contact.getFixtureB();
        Body bodyA = fixtureA.getBody();
        Body bodyB = fixtureB.getBody();
        bodyA.beginContact(contact,fixtureA,fixtureB, true);
        bodyB.beginContact(contact,fixtureA,fixtureB, false);
    }

    @Override
    public void endContact(Contact contact) {
        Fixture fixtureA = contact.getFixtureA();
        Fixture fixtureB = contact.getFixtureB();
        Body bodyA = fixtureA.getBody();
        Body bodyB = fixtureB.getBody();
        bodyA.endContact(contact,fixtureA,fixtureB, true);
        bodyB.endContact(contact,fixtureA,fixtureB, false);
    }

    @Override
    public void preSolve(Contact contact, Manifold oldManifold) {
        Fixture fixtureA = contact.getFixtureA();
        Fixture fixtureB = contact.getFixtureB();
        Body bodyA = fixtureA.getBody();
        Body bodyB = fixtureB.getBody();
        bodyA.preSolve(contact,fixtureA,fixtureB, oldManifold,true);
        bodyB.preSolve(contact,fixtureA,fixtureB, oldManifold,false);

    }

    @Override
    public void postSolve(Contact contact, ContactImpulse impulse) {

    }
}
