package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.esotericsoftware.spine.*;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.assets.GoodData;

public class BallAnimation {
    protected Skeleton skeleton;
    protected AnimationState state;
    protected SkeletonRenderer renderer;
    protected float x, y, rotation;
    protected float rotationOffset = 0;
    protected boolean faceRight = false;
    protected GoodData data;

    public BallAnimation(int id) {
        data = Assets.instance.getGoodData(id, 1);
        init();
    }

    protected void init() {
    }

    public void idle() {

    }

    public void run(float angularVelocity) {


    }

    public void setFaceRight(boolean faceRight) {
        this.faceRight = faceRight;
        skeleton.setFlipX(faceRight);
    }

    public void boom() {

    }

    public void update(float x, float y, float rotation) {
        this.x = x;
        this.y = y;
        if (faceRight) {
            this.rotation = -rotation;
        } else {
            this.rotation = rotation;
        }
        skeleton.setPosition(x, y);
        skeleton.getRootBone().setRotation(this.rotation + rotationOffset);
        state.update(Gdx.graphics.getDeltaTime());
        state.apply(skeleton);
        skeleton.updateWorldTransform();
    }

    public void draw(Batch batch) {
        renderer.draw(batch, skeleton);
    }

}
