package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.esotericsoftware.spine.*;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.spine.MAtlasAttachmentLoader;

public class BouncyBallAnimation extends BallAnimation{
    public BouncyBallAnimation(){
        super(1);
    }

    protected void init() {
        MAtlasAttachmentLoader.prefix = "boom2_";
        renderer = HelloZombieGame.getSkeletonRenderer();
        SkeletonBinary skeletonJson = HelloZombieGame.getSkeletonBinary();
        skeletonJson.setScale(1 / 160F);
        SkeletonData data = skeletonJson.readSkeletonData(Gdx.files.internal("animations/boom2.skel"));
        AnimationStateData animationStateData = new AnimationStateData(data);
        state = new AnimationState(animationStateData);
        skeleton = new Skeleton(data);
        MAtlasAttachmentLoader.prefix = "";
        idle();
    }

    public void idle() {
        state.setTimeScale(1);
 //       rotationOffset = rotation;
        state.setAnimation(0, "idle", true);
    }

    public void run(float angularVelocity) {
        state.setAnimation(0, "move", true);

    }

    public void boom() {
        state.setTimeScale(1F);
  //      rotationOffset = rotation;
        state.setAnimation(0, "boom", false);
    }

}
