package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.PolygonSpriteBatch;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.esotericsoftware.spine.*;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.spine.MAtlasAttachmentLoader;

/**
 * Created by Doodle on 2018/10/17.
 */

public class CommonAnimation extends Actor {
    private Skeleton skeleton;
    private AnimationState state;
    SkeletonRenderer renderer;
    float scale;
    float xOffset;
    float yOffset;
    String prefix;
    public CommonAnimation(String name) {
        this.name = name;
        scale = 1;
        String[]temp = name.split("/");
        String str = temp[1];
        this.prefix = str.substring(0,str.length()-5);
        init();
    }

    public CommonAnimation(String name, float scale) {
        this.scale = scale;
        this.name = name;
        String[]temp = name.split("/");
        String str = temp[1];
        this.prefix = str.substring(0,str.length()-5);
        init();
    }

    public CommonAnimation(String name, float scale,String prefix) {
        this.scale = scale;
        this.name = name;
        this.prefix = prefix;
        init();
    }


    public void setxOffset(float xOffset) {
        this.xOffset = xOffset;
    }

    public void setyOffset(float yOffset) {
        this.yOffset = yOffset;
    }


    private void init() {
        MAtlasAttachmentLoader.prefix =prefix+"_";
        renderer = HelloZombieGame.getSkeletonRenderer();
        SkeletonBinary skeletonJson = HelloZombieGame.getSkeletonBinary();
        skeletonJson.setScale(scale);
        SkeletonData data = skeletonJson.readSkeletonData(Gdx.files.internal(name));
        AnimationStateData animationStateData = new AnimationStateData(data);
        state = new AnimationState(animationStateData);
        skeleton = new Skeleton(data);
        skeleton.setPosition(x, y);
        MAtlasAttachmentLoader.prefix = "";
    }

    public Skeleton getSkeleton() {
        return skeleton;
    }

    public AnimationState getState() {
        return state;
    }
//    public void setScale(float scaleXY){
//        skeleton
//    }


    @Override
    public void act(float delta) {
        super.act(delta);
        state.update(delta);
    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        int c1 = batch.getBlendSrcFunc();
        int c2 = batch.getBlendDstFunc();
        int c3=batch.getBlendSrcFuncAlpha();
        int c4 =batch.getBlendDstFuncAlpha();
        skeleton.setPosition(x+xOffset,y+ yOffset);
        state.apply(skeleton);
        skeleton.setPosition(x+xOffset,y+ yOffset);
        skeleton.updateWorldTransform();
        skeleton.setColor(getColor());
        renderer.draw((PolygonSpriteBatch)batch, skeleton);
        batch.setBlendFunctionSeparate(c1,c2,c3,c4);
    }
}
