package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.ParticleEffect;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.zyb.loveball.HelloZombieGame;

public class CommonParticleEffect extends Actor {

    ParticleEffect effect;

    public CommonParticleEffect(String name, TextureAtlas atlas){
        effect = new ParticleEffect();
        effect.load(Gdx.files.internal(name), atlas);
    }

    @Override
    public void setPosition(float x, float y) {
        super.setPosition(x, y);
        effect.setPosition(x,y);
    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        if(effect.isComplete()){
            remove();
        }
        effect.update(Gdx.graphics.getDeltaTime());
        effect.draw(HelloZombieGame.getBatch());
    }
}
