package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.esotericsoftware.spine.*;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.spine.MAtlasAttachmentLoader;

/**
 * Created by Doodle on 2018/10/25.
 */

public class FlyZombieAnimation extends ZombieAnimation{
    @Override
    public void init() {
        MAtlasAttachmentLoader.prefix ="zombie2_";
        renderer = HelloZombieGame.getSkeletonRenderer();
        SkeletonBinary skeletonJson = HelloZombieGame.getSkeletonBinary();
        skeletonJson.setScale(1 / 160F);
//        SkeletonData data = HelloZombieGame.getFlyData();
        SkeletonData data = skeletonJson.readSkeletonData(Gdx.files.internal("animations/zombie2.skel"));
        AnimationStateData animationStateData = new AnimationStateData(data);
        animationStateData.setMix("1","2",0.5f);
        animationStateData.setMix("2","1",0.5f);
        state = new AnimationState(animationStateData);
        skeleton = new Skeleton(data);
        MAtlasAttachmentLoader.prefix="";
        xOffset = 0F;
    }

    @Override
    public void idle() {
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(0, "1", true);
    }

    @Override
    public void scared() {
        state.setTimeScale(1);
        rotationOffset = rotation;
//        state.setAnimation(0, "2", false);
        state.addAnimation(0, "2", true, 0.2F);
    }

}
