package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.math.MathUtils;
import com.esotericsoftware.spine.*;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.spine.MAtlasAttachmentLoader;

public class NormalBallAnimation extends BallAnimation{
    public NormalBallAnimation(int id){
        super(id);
    }

    protected void init() {
        FileHandle file = Gdx.files.internal("animations/"+this.data.getAnimation()+".skel");
        MAtlasAttachmentLoader.prefix = data.getAnimation()+"_";
        renderer = HelloZombieGame.getSkeletonRenderer();
        SkeletonBinary skeletonJson = HelloZombieGame.getSkeletonBinary();
        skeletonJson.setScale(1 / 160F);
        SkeletonData data = skeletonJson.readSkeletonData(file);
        AnimationStateData animationStateData = new AnimationStateData(data);
        animationStateData.setMix("idle", "move", 0.3F);
        state = new AnimationState(animationStateData);
        skeleton = new Skeleton(data);
        MAtlasAttachmentLoader.prefix = "";
        idle();
    }

    public void idle() {
        System.out.println("idle");
        state.setTimeScale(1);
 //       rotationOffset = rotation;
        state.setAnimation(0, "idle", true);
    }

    public void run(float angularVelocity) {
        float timeScale = Math.abs(angularVelocity) * 1.5F;
        timeScale = MathUtils.clamp(timeScale, 1F, 2.5F);
        System.out.println("run");
        state.setTimeScale(timeScale);
        state.setAnimation(0, "star", false);
        state.addAnimation(0, "move", true, 2F);

    }

    public void boom() {
        state.setTimeScale(1F);
  //      rotationOffset = rotation;
        state.setAnimation(0, "boom", false);
    }

}
