package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.esotericsoftware.spine.*;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.spine.MAtlasAttachmentLoader;

/**
 * Created by Doodle on 2018/10/25.
 */

public class StandZombieAnimation extends ZombieAnimation{
    @Override
    public void init() {
        MAtlasAttachmentLoader.prefix = "zombie_";
        renderer = HelloZombieGame.getSkeletonRenderer();
        SkeletonBinary skeletonJson = HelloZombieGame.getSkeletonBinary();
        skeletonJson.setScale(1 / 160F);
        SkeletonData data = skeletonJson.readSkeletonData(Gdx.files.internal("animations/zombie.skel"));
        AnimationStateData animationStateData = new AnimationStateData(data);
        animationStateData.setMix("3","1",0.5f);
        state = new AnimationState(animationStateData);
        skeleton = new Skeleton(data);
        xOffset = 0.08F;
        MAtlasAttachmentLoader.prefix = "";
    }

    @Override
    public void idle() {
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(0, "1", true);
    }

    @Override
    public void scared() {
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(0, "2", false);
        state.addAnimation(0, "3", true, 0.2F);
    }


}
