package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.PolygonSpriteBatch;
import com.esotericsoftware.spine.*;
import com.zyb.loveball.HelloZombieGame;

/**
 * Created by Doodle on 2018/10/25.
 */

public class WarpGateAnimation {
    protected Skeleton skeleton;
    protected AnimationState stateBg;
    protected AnimationState state;
    SkeletonRenderer renderer;
    float x, y, rotation;
    float rotationOffset = 0;
    boolean isIn;



    public WarpGateAnimation(float x,float y,float rotation,boolean isIn) {
        this.x = x;
        this.y = y;
        this.isIn = isIn;
        this.rotation = rotation;
        init();
    }

    public void init() {
        renderer = HelloZombieGame.getSkeletonRenderer();
        SkeletonBinary skeletonJson = HelloZombieGame.getSkeletonBinary();
        skeletonJson.setScale(1 / 140F);
        SkeletonData data = skeletonJson.readSkeletonData(Gdx.files.internal("animations/door.skel"));
        AnimationStateData animationStateData = new AnimationStateData(data);
        state = new AnimationState(animationStateData);
        stateBg = new AnimationState(animationStateData);
        animationStateData.setMix("in", "in2", 0.5F);
        animationStateData.setMix("out", "out2", 0.5F);
        skeleton = new Skeleton(data);
        skeleton.setPosition(x, y);
        skeleton.getRootBone().setRotation(rotation);
        if(isIn){
            idleIn();
        }else {
            idleOut();
        }
    }

    public void idleIn() {
        System.out.println("idleIn");
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(1, "in2", true);
    }
    public void idleOut() {
        System.out.println("idleOut");
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(1, "out2", true);
    }
    public void in(){
        System.out.println("");
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(1, "in", false);
        state.addAnimation(1,"in2",true,0.5f);

    }
    public void out(){
        System.out.println("out");
        state.setTimeScale(1);
        rotationOffset = rotation;
        state.setAnimation(1, "out", false);
        state.addAnimation(1,"out2",true,0.5f);
    }


    public void update() {
        state.update(Gdx.graphics.getDeltaTime());
        state.apply(skeleton);
        skeleton.update(Gdx.graphics.getDeltaTime());
        skeleton.updateWorldTransform();
    }

    public void draw(Batch batch) {
        renderer.draw((PolygonSpriteBatch) batch, skeleton);
    }
}
