package com.zyb.loveball.animations;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.PolygonSpriteBatch;
import com.esotericsoftware.spine.*;

public class ZombieAnimation {
    protected Skeleton skeleton;
    protected AnimationState state;
    SkeletonRenderer renderer;
    float x, y, rotation;
    float rotationOffset = 0;
    float xOffset,yOffset;


    public ZombieAnimation() {
        xOffset = 0;
        yOffset = -0.241F;
        init();
    }

    public void init() {
//        renderer = HelloZombieGame.getSkeletonRenderer();
//        SkeletonJson skeletonJson = HelloZombieGame.getSkeletonJson();
//        skeletonJson.setScale(1 / 80F);
//        SkeletonData data = skeletonJson.readSkeletonData(Gdx.files.internal("animations/zombie.json"));
//        AnimationStateData animationStateData = new AnimationStateData(data);
//        state = new AnimationState(animationStateData);
//        skeleton = new Skeleton(data);
    }

    public void idle() {
//        System.out.println("idle");
//        state.setTimeScale(1);
//        rotationOffset = rotation;
//        state.setAnimation(0, "1", true);
//        skeleton.setFlipX(faceLeft);
//        System.out.println("face left" + faceLeft);
    }

    public void faceLeft(boolean faceLeft) {
        skeleton.setFlipX(faceLeft);
    }

    public void scared() {
//        System.out.println("scared");
//        state.setTimeScale(1);
//        rotationOffset = rotation;
//        state.setAnimation(0, "2", false);
//        state.addAnimation(0, "3", true, 0.2F);
//        skeleton.setFlipX(faceLeft);
    }

    public void boom(int ballId) {
        state.setTimeScale(1F);
        rotationOffset = rotation;
        if(ballId == 3|| ballId == 4){
            state.setAnimation(0, "die", false);
        }else {
            state.setAnimation(0, "4", false);
        }
    }

    public void happy(){
        state.setAnimation(0, "happy", false);
    }

    public void update(float x, float y) {
        this.x = x;
        this.y = y;
        skeleton.setPosition(x+xOffset, y +yOffset);
        skeleton.getRootBone().setRotation(this.rotation - rotationOffset);
        state.update(Gdx.graphics.getDeltaTime());
        state.apply(skeleton);
        skeleton.updateWorldTransform();
    }

    public void draw(Batch batch) {
        renderer.draw((PolygonSpriteBatch) batch, skeleton);
    }

}
