package com.zyb.loveball.assets;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Preferences;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.utils.FlurryUtils;

import java.text.DecimalFormat;

public class Configuration {
    public static SettingData settingData;
    private static Preferences preferences;
    public static boolean unlock = false;
    public static boolean box2dDebug = false;
    public static boolean debug = false;
    public static boolean videoAdReady = false;
    public static float game_time;
    public static float full_screen_time;
    public static int retry_times_full_screen;
    public static boolean poor = false;
    public static String device_name = "";
    public static int width;
    public static int height;
    public static int screen_width = 480;
    public static int screen_height = 800;
    public static int numSamples = 4;
    public static int avaliableMem;
    public static int APILevel = 19;

    public static DecimalFormat numType = new DecimalFormat("#,###");

    public static void init_device() {
        if (screen_width < 480 ||
                screen_height < 800 ||
                (screen_width * screen_height < 800 * 480) ||
                "DROID X2".equals(device_name) ||
                "MT25i".equals(device_name)) {
            poor = true;
        } else {
            poor = false;
        }
    }

    public static void prepare(){
        preferences = Gdx.app.getPreferences("game_data");
        if(Gdx.gl20 == null){
            poor = true;
        }
        reset();
        loadSettingData();
    }

    public static void reset() {
        //     banner_times = 0;
        game_time = 0;
        //       banner_times = 0;
        full_screen_time = 0;
        retry_times_full_screen = 0;
        //       bannerShow = false;
    }

    private static void loadSettingData() {
        String data = preferences.getString("setting_data", "");
        if (!"".equals(data)) {
            try {
                settingData = HelloZombieGame.getJson().fromJson(SettingData.class, data);
                if (settingData.isFirstPlay()) {
                    settingData.setFirstPlay(false);
                    FlurryUtils.level_FirstWin(settingData.getUnlockChapter(), settingData.getUnlockLevel());
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        if (settingData == null) {
            settingData = new SettingData();
        }
    }

    public static void saveData() {
        if (settingData == null) return;
        preferences.putString("setting_data", settingData.toString());
        preferences.flush();
    }

    public static void resetData() {
        settingData = new SettingData();
        saveData();
    }
}
