package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2018/11/16.
 */

public class ChallengeQuitDialog extends BaseDialog{
    ConfirmListener confirmListener;

    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_yes").addListener(new SoundButtonListener(){
            @Override
            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
                super.touchUp(event, x, y, pointer, button);
                close();
                confirmListener.confirm();
            }
        });

        group.findActor("btn_no").addListener(new SoundButtonListener(){
            @Override
            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
                super.touchUp(event, x, y, pointer, button);
                close();
            }
        });
    }

    public void setConfirmListener(ConfirmListener confirmListener) {
        this.confirmListener = confirmListener;
    }

    public static interface ConfirmListener{
        public void confirm();
    }

}
