package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.utils.listener.ButtonListener;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2018/9/17.
 */

public class CoinDialog extends BaseDialog {
    CoinDialogListener coinDialogListener;
    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_yes", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                if(coinDialogListener!=null){
                    close();
                    coinDialogListener.playVideoAds();
                }
            }
        });
        group.findActor("btn_no", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                close();
            }
        });
    }

    @Override
    public void update() {
        super.update();
        if(Configuration.videoAdReady){
            group.findActor("btn_yes").setTouchable(Touchable.enabled);
            group.findActor("btn_gray").setVisible(false);
        }else{
            group.findActor("btn_yes").setTouchable(Touchable.disabled);
            group.findActor("btn_gray").setVisible(true);
        }
    }

    public void setCoinDialogListener(CoinDialogListener coinDialogListener) {
        this.coinDialogListener = coinDialogListener;
    }

    public interface CoinDialogListener{
        public void playVideoAds();
    }
}
