package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.zyb.loveball.constants.Constant;
import com.zyb.loveball.utils.listener.ButtonListener;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2018/11/16.
 */

public class ConfirmDialog extends BaseDialog{

    Label titleLabel;
    Label contentLabel;
    @Override
    public void show(Group parent) {
        super.show(parent);
        titleLabel = group.findActor("font_title");
        contentLabel = group.findActor("font_text");
        contentLabel.setAlignment(Align.center);
        float ff=contentLabel.getX(Align.center);
        contentLabel.setWidth(360);
        contentLabel.setX(ff,Align.center);
        contentLabel.setWrap(true);
    }

    public void setTitle(String title){
        titleLabel.setText(title);
    }

    public void setContent(String content){
        contentLabel.setText(content);
    }

    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_ok").addListener(new SoundButtonListener(){
            @Override
            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
                super.touchUp(event, x, y, pointer, button);
                close();
            }
        });
    }
}
