package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.screens.BaseScreen;
import com.zyb.loveball.screens.ChallengeScreen;
import com.zyb.loveball.utils.Log;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2018/9/12.
 */

public class FailureDialog extends BaseDialog {
    ReviveDialogListener reviveDialogListener;

    @Override
    public void load(Group group) {
        super.load(group);
//        Grid grid = new Grid();
//        grid.setNeedBg(false);
//        grid.setColor(new Color(249 / 255f, 250 / 255f, 233 / 255f, 1));
//        grid.setSize(480, 1200);
//        grid.setY(-200);
//        group.addActorAt(0, grid);
    }

    @Override
    protected void layout() {
        super.layout();
        group.setY((HelloZombieGame.getViewport().getWorldHeight() - 800) / 2 + group.getY());

    }


    @Override
    public void show(Group parent) {
        super.show(parent);
        parent.addActor(group);
        group.setTouchable(Touchable.enabled);
        HelloZombieGame.resumeInputProcessor();
        Actor actor = group.findActor("coin_font");
        if(actor!=null){
            coinLabel = (Label)actor;
            Log.log("SuccessDialog","find coin label");
        }
        update();
    }

    @Override
    protected void initButtons() {
        group.findActor("btn_no", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                baseListener.screenEnd(ChallengeScreen.class);
            }

        });
        group.findActor("btn_yes", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                reviveDialogListener.playVideo(BaseScreen.PendingAction.REVIVE,1);
            }
        });
//        group.findActor("btn_return", Touchable.enabled).addListener(new SoundButtonListener() {
//            @Override
//            public void touchUpEffect() {
//                super.touchUpEffect();
//                reviveDialogListener.notRevive();
//            }
//        });
//        group.findActor("money", Touchable.enabled).addListener(new ClickListener() {
//            @Override
//            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
//                reviveDialogListener.addMoneyButton();
//                return super.touchDown(event, x, y, pointer, button);
//            }
//        });
    }


    public void setReviveDialogListener(ReviveDialogListener reviveDialogListener) {
        this.reviveDialogListener = reviveDialogListener;
    }

    public interface ReviveDialogListener {
        public void playVideo(BaseScreen.PendingAction action, int pendingValue);
//
//        public void notRevive();
//
//        public void addMoneyButton();
    }
}
