package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.zyb.loveball.GameInfo;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.audio.AudioProcess;
import com.zyb.loveball.screens.ChallengeScreen;
import com.zyb.loveball.screens.LevelScreen;
import com.zyb.loveball.screens.MenuScreen;
import com.zyb.loveball.utils.listener.ButtonListener;
import com.zyb.loveball.utils.listener.SoundButtonListener;

/**
 * Created by Doodle on 2018/9/12.
 */

public class PauseDialog extends BaseDialog {

    PauseDialogListener pauseDialogListener;

    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_continue", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                close();
            }

        });
        group.findActor("btn_home", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                System.out.println("home!!!!!");
//                baseListener.screenEnd(MenuScreen.class);
                pauseDialogListener.home();
            }

        });
        group.findActor("btn_menu", Touchable.enabled).addListener(new SoundButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                System.out.println("menu!!!!!");
                pauseDialogListener.menu();
            }

        });
        group.findActor("btn_sound", Touchable.enabled).addListener(new ClickListener() {
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                Actor btnOn = ((Group)group.findActor("btn_sound")).findActor("btn_sound");
                boolean soundOn = !Configuration.settingData.isSound();
                btnOn.setVisible(soundOn);
                Configuration.settingData.setSound(soundOn);
                if(soundOn){
                    AudioProcess.playAllSound();
                }else {
                    AudioProcess.stopAllSound();
                }
                return super.touchDown(event, x, y, pointer, button);
            }
        });

        group.findActor("btn_music", Touchable.enabled).addListener(new ClickListener() {
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                Actor btnOn = ((Group)group.findActor("btn_music")).findActor("btn_music");
                boolean musicOn = !Configuration.settingData.isMusic();
                btnOn.setVisible(musicOn);
                Configuration.settingData.setMusic(musicOn);
                if(musicOn){
                    AudioProcess.playMusicLoop();
                }else{
                    AudioProcess.stopAllMusic();
                }
                return super.touchDown(event, x, y, pointer, button);
            }
        });
    }

    @Override
    public void update() {
        super.update();
        Actor btnOn = ((Group)group.findActor("btn_music")).findActor("btn_music");
        boolean musicOn = Configuration.settingData.isMusic();
        btnOn.setVisible(musicOn);
        btnOn = ((Group)group.findActor("btn_sound")).findActor("btn_sound");
        boolean soundOn = Configuration.settingData.isSound();
        btnOn.setVisible(soundOn);
    }

    public void setPauseDialogListener(PauseDialogListener pauseDialogListener) {
        this.pauseDialogListener = pauseDialogListener;
    }

    public static interface PauseDialogListener{
        public void home();
        public void menu();
    }
}
