package com.zyb.loveball.dialogs;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.badlogic.gdx.utils.Align;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.audio.AudioProcess;
import com.zyb.loveball.utils.listener.ButtonListener;
import com.zyb.loveball.utils.listener.SoundButtonListener;

public class SettingDialog extends BaseDialog{
    private boolean notificationOn;
    Actor btnMusic;
    Actor btnSound;
    Actor btnNotification;

    @Override
    public void load(Group group) {
        super.load(group);
        notificationOn = Configuration.settingData.isNotification();
        btnSound = ((Group)group.findActor("btn_sound")).findActor("btn_sound");
        btnSound.setVisible(Configuration.settingData.isSound());
        btnMusic = ((Group)group.findActor("btn_music")).findActor("btn_music");
        btnMusic.setVisible(Configuration.settingData.isMusic());
        btnNotification =((Group)group.findActor("btn_notification")).findActor("btn_notification");
        btnNotification.setVisible(Configuration.settingData.isNotification());
    }

    @Override
    protected void initButtons() {
        super.initButtons();
        group.findActor("btn_language", Touchable.enabled).addListener(new SoundButtonListener(){
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                ///////////////////////
            }
        });

        group.findActor("btn_rate", Touchable.enabled).addListener(new SoundButtonListener(){
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                HelloZombieGame.launcherListener.rate();
                ///////////////////////
            }
        });

        group.findActor("btn_sound", Touchable.enabled).addListener(new ClickListener() {
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                boolean soundOn = !Configuration.settingData.isSound();
                btnSound.setVisible(soundOn);
                Configuration.settingData.setSound(soundOn);
                if(soundOn){
                    AudioProcess.playAllSound();
                }else {
                    AudioProcess.stopAllSound();
                }
                return super.touchDown(event, x, y, pointer, button);
            }
        });
        group.findActor("btn_music", Touchable.enabled).addListener(new ClickListener() {
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                boolean musicOn = !Configuration.settingData.isMusic();
                btnMusic.setVisible(musicOn);
                Configuration.settingData.setMusic(musicOn);
                if(musicOn) {
                    AudioProcess.playMusicLoop();
                }else{
                    AudioProcess.stopAllMusic();
                }
                return super.touchDown(event, x, y, pointer, button);
            }
        });
        Actor btnNotification = group.findActor("btn_notification");
        btnNotification.setOrigin(Align.center);
        btnNotification.setTouchable(Touchable.enabled);
        btnNotification.addListener(new ButtonListener() {
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                Actor btnOn = ((Group)group.findActor("btn_notification")).findActor("btn_notification");
                btnOn.setVisible(!btnOn.isVisible());
                Configuration.settingData.setNotification(btnOn.isVisible());
                return super.touchDown(event, x, y, pointer, button);
            }
        });
    }

}
