package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.physics.box2d.BodyContactAdapter;
import com.badlogic.gdx.physics.box2d.Contact;
import com.badlogic.gdx.physics.box2d.Fixture;
import com.badlogic.gdx.physics.box2d.PolygonShape;
import com.badlogic.gdx.physics.box2d.World;
import com.badlogic.gdx.utils.Array;
import com.zyb.loveball.GamePanel;
import com.zyb.loveball.assets.Assets;

/**
 * Created by Doodle on 2018/10/23.
 */

public class AntiGravity extends BaseObject {
    TextureRegion regionUp;
    TextureRegion regionDown;
    GamePanel gamePanel;
    static GravityStatus gravityStatus;
    float x,y;
    float width,height;
    public AntiGravity(Body body,GamePanel gamePanel) {
        super(gamePanel);
        this.body = body;
        this.gamePanel = gamePanel;
        this.regionUp = Assets.instance.game.findRegion("anti_gravity_up");
        this.regionDown = Assets.instance.game.findRegion("anti_gravity_down");
        this.x = body.getPosition().x;
        this.y = body.getPosition().y;
        this.gravityStatus = GravityStatus.down;
        Vector2 vector2 = new Vector2();
        ((PolygonShape)body.getFixtureList().get(0).getShape()).getVertex(0,vector2);
        this.width = Math.abs(vector2.x*2);
        this.height = Math.abs(vector2.y*2);
        body.setContactListener(contactListener);
    }
    BodyContactAdapter contactListener = new BodyContactAdapter() {
        @Override
        public void beginContact(Contact contact, Fixture fixtureA,Fixture fixtureB,boolean isA) {
            super.beginContact(contact,fixtureA,fixtureB, isA);
            Body body;
            if (isA) {
                body = fixtureB.getBody();
            } else {
                body = fixtureA.getBody();
            }
            String name = gamePanel.getScene().getName(body);
            if(name!=null && name.startsWith("ball")) {
                World world = gamePanel.getWorld();
                Array<Body> bodies = new Array<>();
                world.getBodies(bodies);
                for(Body body1:bodies){
                    body1.setAwake(true);
                }
                world.setGravity(world.getGravity().rotate(180f));
                if(gravityStatus == GravityStatus.down) {
                    gravityStatus = GravityStatus.up;
                }
                else if(gravityStatus ==GravityStatus.up) {
                    gravityStatus = GravityStatus.down;
                }
            }
        }

    };

    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        if(gravityStatus == GravityStatus.down){
            batch.draw(regionUp,x-width/2,y-height/2,0,0,width,height,1,1,0);
        }else if(gravityStatus == GravityStatus.up){
            batch.draw(regionDown,x-width/2,y-height/2,0,0,width,height,1,1,0);
        }
    }
    public enum GravityStatus{
        up,down
    }
}
