package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.PolygonRegion;
import com.badlogic.gdx.graphics.g2d.PolygonSpriteBatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.CircleShape;
import com.badlogic.gdx.physics.box2d.PolygonShape;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.utils.MathUtil;

public class CirecleStaticObject extends StaticObject{

    public Color color;
    float x,y,radius;
    int segments;

    public CirecleStaticObject(CircleShape shape, Vector2 position){
        color = new Color(140/255f,187/255f,198/255f,1);
        x = position.x;
        y = position.y;
        TextureRegion baseRegion = Assets.instance.ui.findRegion("white");
        radius = shape.getRadius();
        int size = (int)(50 * radius);
        segments = MathUtils.clamp(size,20,Integer.MAX_VALUE);
        vertexes = new float[size*2];
        float perOffset = 360F/size;
        for (int i = 0;i<size;i++){
            double angle = (2*Math.PI/360) * i * perOffset;
            vertexes[2*i] =  position.x+ (float) Math.sin(angle)* radius;
            vertexes[2*i+1] =position.y -  (float)Math.cos(angle)* radius;
        }
        polygonRegion =new PolygonRegion(baseRegion,vertexes,MathUtil.computeTriangles(vertexes).toArray());
        float[] textureCoords = polygonRegion.getTextureCoords();
        float u = baseRegion.getU();
        float v = baseRegion.getV();
        float u2 = baseRegion.getU2();
        float v2 = baseRegion.getV2();
        for (int i = 0; i < textureCoords.length; i += 2) {
            textureCoords[i] = MathUtils.clamp(textureCoords[i], u, u2);
            textureCoords[i + 1] = MathUtils.clamp(textureCoords[i + 1], v, v2);
        }
    }

    public void draw(PolygonSpriteBatch batch, float parentAlpha){
        batch.setColor(color);
        batch.draw(polygonRegion,0,0);
    }

    public void draw(ShapeRenderer shapeRenderer, float parentAlpha){
    //    shapeRenderer.circle(x,y,radius,segments);
    }
}
