package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.constants.Constant;
import com.zyb.loveball.utils.LayerUtils;

public class GameBg {
    NinePatch bg;
    TextureRegion gridRegion;
    private boolean drawable = true;

    public GameBg(){
        bg = LayerUtils.createLayerNinePatch(0.6F);
        bg.setColor(new Color(249/255f,250/255f,232/255f,1));
        gridRegion = Assets.instance.ui.findRegion("bg_net");
    }

    public void setDrawable(boolean drawable) {
        this.drawable = drawable;
    }

    public void draw(Batch batch, float parentAlpha) {
        if(!drawable) return;
        batch.setColor(1,1,1,1);
        bg.draw(batch,-0.625f,-1f,0,0,580,1200,Constant.SCALE,Constant.SCALE,0);
        batch.draw(gridRegion,0,0,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
        batch.draw(gridRegion,0,10,0,0,480,800,Constant.SCALE,Constant.SCALE,0);
    }

}
