package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.utils.Array;
import com.badlogic.gdx.utils.FloatArray;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.utils.MathUtil;

/**
 * Created by Doodle on 2018/9/30.
 */

public class HintLine{
    NinePatch ninePatch;
    FloatArray vertexes = new FloatArray();
    boolean visible;
    public HintLine() {
        TextureRegion tmpRegion = Assets.instance.game.findRegion(Assets.instance.getGoodData(Configuration.settingData.getPenId(),0).getResources()+"_line");
        if(tmpRegion ==null){
            tmpRegion = Assets.instance.game.findRegion("pen_lanqianbi_line");
        }
        this.ninePatch = new NinePatch(tmpRegion,8,8,0,0);
    }
    public void setHintVertexes(float[] origins){
        vertexes.clear();
        float sumLength = 0;
        FloatArray pointArray = MathUtil.cubicSplineInterpolation(new FloatArray(origins));
        vertexes.add(pointArray.get(0));
        vertexes.add(pointArray.get(1));
        for (int i = 2; i < pointArray.size; i += 2) {
            if (pointArray.size <= 2) break;
            float offsetX = pointArray.get(i)-pointArray.get(i-2);
            float offsetY = pointArray.get(i+1)-pointArray.get(i-1);
            float lastLength = (float) Math.sqrt(offsetX*offsetX+offsetY*offsetY);
            sumLength += lastLength;
            while (sumLength>=0.1f){
                float x=pointArray.get(i)-(offsetX/lastLength*(sumLength-0.1F));
                float y=pointArray.get(i+1)-(offsetY/lastLength*(sumLength-0.1F));
                sumLength -= 0.1f;
                vertexes.add(x);
                vertexes.add(y);
            }
        }
        vertexes.add(pointArray.get(pointArray.size-2));
        vertexes.add(pointArray.get(pointArray.size-1));
    }

    public void setVisible(boolean visible) {
        this.visible = visible;
    }

    public void draw(Batch batch, float parentAlpha) {
        if(!visible) return;
//        ninePatch.setColor(getColor());
        for(int i = 0;i<vertexes.size/2-1;i++){
            ninePatch.draw(batch,
                        vertexes.get(2*i)-8,
                        vertexes.get(2*i+1)-8,
                        8,
                        8,
                        16f,
                        16f,
                        0.003f,
                        0.003f,
                        0);
        }

    }

    public FloatArray getVertexes() {
        return vertexes;
    }
}
