package com.zyb.loveball.objects;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.*;
import com.zyb.loveball.GamePanel;
import com.zyb.loveball.assets.Assets;

/**
 * Created by Doodle on 2018/10/24.
 */

public class InkBottle extends BaseObject {
    GamePanel gamePanel;
    TextureRegion region;
    float bodyX, bodyY;
    float regionWidth;
    float regionHeight;

    public InkBottle(Body body, GamePanel gamePanel) {
        super(gamePanel);
        this.body = body;
        this.gamePanel = gamePanel;
        bodyX = body.getPosition().x;
        bodyY = body.getPosition().y;
        region = Assets.instance.game.findRegion("ink_bottle");
        Vector2 point = new Vector2();
        ((PolygonShape) body.getFixtureList().get(0).getShape()).getVertex(0, point);
        regionWidth = (float) region.getRegionWidth() / region.getRegionHeight() * Math.abs(point.y * 2);
        regionHeight = Math.abs(point.y * 2);
        body.setContactListener(bodyContactListener);
    }

    BodyContactListener bodyContactListener = new BodyContactAdapter() {
        @Override
        public void beginContact(Contact contact, Fixture fixtureA,Fixture fixtureB,boolean isA) {
            super.beginContact(contact,fixtureA,fixtureB, isA);
            Body tmpBody;
            if (isA) {
                tmpBody = fixtureB.getBody();
            } else {
                tmpBody = fixtureA.getBody();
            }
            String name = gamePanel.getScene().getName(tmpBody);
            if (name != null && name.startsWith("ball")) {
                gamePanel.removeObject(body);
                gamePanel.getPaintPanel().pen.addInk();
                gamePanel.updateUI();
            }
        }
    };


    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        batch.draw(region, bodyX - regionWidth / 2, bodyY - regionHeight / 2, 0, 0, regionWidth, regionHeight, 1, 1, 0);
    }
}
