package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.PolygonRegion;
import com.badlogic.gdx.graphics.g2d.PolygonSpriteBatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.PolygonShape;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.utils.MathUtil;

public class PolygonStaticObject extends StaticObject{
    Vector2 tmpVector = new Vector2();
    public Color color;
    public Color oldColor;
    public PolygonStaticObject(PolygonShape shape, Vector2 position,float angle){
        //angle = (float) (angle/Math.PI * 180);
        color = new Color(140/255f,187/255f,198/255f,1);
        TextureRegion baseRegion = Assets.instance.ui.findRegion("white");
        int size = shape.getVertexCount();
        vertexes = new float[size*2];
        for (int i = 0;i<size;i++){
            shape.getVertex(i,tmpVector);
            float length = tmpVector.len();
            float localAngle = (float) (MathUtil.getAngle(0,0,tmpVector.x,tmpVector.y));
            vertexes[2*i] =(float) (position.x + Math.cos(localAngle + angle) * length);
            vertexes[2*i+1] = (float) (position.y + Math.sin(localAngle + angle) * length);
        }
        polygonRegion =new PolygonRegion(baseRegion,vertexes,MathUtil.computeTriangles(vertexes).toArray());
        float[] textureCoords = polygonRegion.getTextureCoords();
        float u = baseRegion.getU();
        float v = baseRegion.getV();
        float u2 = baseRegion.getU2();
        float v2 = baseRegion.getV2();
        for (int i = 0; i < textureCoords.length; i += 2) {
            textureCoords[i] = MathUtils.clamp(textureCoords[i], u, u2);
            textureCoords[i + 1] = MathUtils.clamp(textureCoords[i + 1], v, v2);
        }
    }

    public void draw(PolygonSpriteBatch batch, float parentAlpha){
        oldColor = batch.getColor();
        batch.setColor(color);
        batch.draw(polygonRegion,0,0);
        batch.setColor(oldColor);

    }

    public void draw(ShapeRenderer shapeRenderer, float parentAlpha){
    //    shapeRenderer.polygon(vertexes);
    }
}
