package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.utils.TextureRegionDrawable;
import com.zyb.loveball.assets.Assets;

/**
 * Created by Doodle on 2018/9/25.
 */

public class ProgressBar {
    TextureRegion region;
    TextureRegion barRegion;
    TextureRegionDrawable drawable;
    int width;
    int height;
    Actor bar;
    Label label;

    public ProgressBar(Actor bar, Label label) {
        this.bar = bar;
        this.label = label;
        region = ((TextureRegionDrawable) ((Image) bar).getDrawable()).getRegion();
        barRegion = new TextureRegion();
        drawable = (TextureRegionDrawable) ((Image) bar).getDrawable();
        width = (int) bar.getWidth();
        height = (int) bar.getHeight();
    }

    public void update(float percent) {
        float tempWidth = width * percent;
        barRegion.setRegion(region, 0, 0, (int) tempWidth, height);
        drawable.setRegion(barRegion);
        bar.setWidth(tempWidth);
        if (label != null) {
            label.setText(((int) (percent * 100)) + "%");
        }
    }
}
