package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.utils.MathUtil;

/**
 * Created by Doodle on 2018/9/20.
 */

public class PromptLine{
    private NinePatch promptLineNinePatch;
    private float x1,y1,x2,y2;
    private float length;
    private boolean visible;
    private Color color;

    public PromptLine(float x1,float y1,float x2,float y2){
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
        TextureRegion tmpRegion = Assets.instance.game.findRegion(Assets.instance.getGoodData(Configuration.settingData.getPenId(),0).getResources()+"_line");
        if(tmpRegion ==null){
            tmpRegion = Assets.instance.game.findRegion("pen_lanqianbi_line");
        }
        promptLineNinePatch = new NinePatch(tmpRegion,8,8,0,0);
        promptLineNinePatch.setColor(new Color(1,1,1,0.5F));
    }
    public void update(float x1, float y1, float x2, float y2){
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
        length = (float) Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
    }

    public void setVisible(boolean visible) {
        this.visible = visible;
        length = 0;
    }

    public void draw(Batch batch) {
        if(!visible || length == 0) return;
        promptLineNinePatch.draw(batch,x1-8, y1-8, 8F, 8f, length*250+2, 16F, 0.004f, 0.004f, (float) (MathUtil.getAngle(x1, y1, x2, y2) / Math.PI * 180));
    }
}
