package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.zyb.loveball.assets.Assets;

/**
 * Created by Doodle on 2018/11/7.
 */

public class SpecialFateOut extends Actor {
    NinePatch ninePatch;
    Vector2 zombiePosition;
    float speed = 30;
    public SpecialFateOut(Vector2 zombiePosition) {
        TextureRegion region = Assets.instance.ui.findRegion("circle_black");
        this.zombiePosition = zombiePosition;
        this.ninePatch = new NinePatch(region,1,1,1,1);
        ninePatch.setLeftWidth(zombiePosition.x);
        ninePatch.setRightWidth(480-zombiePosition.x);
        ninePatch.setBottomHeight(zombiePosition.y);
        ninePatch.setTopHeight(1000-zombiePosition.y);
    }
    float stateTime = 0;
    @Override
    public void act(float delta) {
        super.act(delta);
        stateTime+=delta;
        if(stateTime>=3){
            this.remove();
        }
    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        ninePatch.setLeftWidth(ninePatch.getLeftWidth()-speed);
        ninePatch.setRightWidth(ninePatch.getRightWidth()-speed);
        ninePatch.setTopHeight(ninePatch.getTopHeight()-speed);
        ninePatch.setBottomHeight(ninePatch.getBottomHeight()-speed);
        ninePatch.draw(batch,0,0,480,1000);
    }


}
