package com.zyb.loveball.objects;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.physics.box2d.PolygonShape;
import com.zyb.loveball.GamePanel;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.utils.MathUtil;

/**
 * Created by Doodle on 2018/11/15.
 */

public class SquareDynamic extends BaseObject{
    NinePatch ninePatch;
    Vector2 position;
    float rotation;
    float width,height;
    float targetScale = 1/160f;
    public SquareDynamic(Body body ,GamePanel gamePanel) {
        super(gamePanel);
        this.body = body;
        ninePatch = new NinePatch(Assets.instance.game.findRegion("square_dynamic"),20,20,20,20);
        Vector2 temp = new Vector2();
        ((PolygonShape)body.getFixtureList().get(0).getShape()).getVertex(0,temp);
        width = Math.abs(temp.x*2/targetScale);
        height = Math.abs(temp.y*2/targetScale);
    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        position = body.getPosition();
        rotation = body.getAngle()/MathUtils.PI*180;
        ninePatch.draw(batch,position.x-width/2,position.y-height/2,width/2,height/2,width,height,targetScale,targetScale,rotation);
    }
}
