package com.zyb.loveball.screens;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.zyb.loveball.HelloZombieGame;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.ui.StorePanel;
import com.zyb.loveball.utils.listener.ButtonListener;
import com.zyb.loveball.utils.listener.LClickListener;

import java.text.DecimalFormat;

/**
 * Created by Doodle on 2018/11/7.
 */

public class StoreScreen extends BaseScreen{
    StorePanel ballPanel;
    StorePanel penPanel;
    private boolean isBall = true;
//    final public static int[] pen = {0, 100, 200, 500, 1000, 2000, 5000, 10000};
//    final public static int[] ball = {0, 100, 200, 500, 1000, 2000, 5000, 10000};

    public StoreScreen(HelloZombieGame game) {
        super(game);
        TAG = "store";
    }

    @Override
    public void show() {
        super.show();
        ballPanel = new StorePanel(1);
        penPanel = new StorePanel(0);
        StorePanel.StorePanelListener listener = new StorePanel.StorePanelListener() {
            @Override
            public void update() {
                StoreScreen.this.update();
            }

            @Override
            public void showCoinDialog() {
                StoreScreen.this.showCoinDialog();
            }
        };
        ballPanel.show(listener,groups[CENTER]);
        penPanel.show(listener,groups[CENTER]);
        updateUI();
        initButtons();
        update();
        stage.addListener(new ClickListener());
    }

    private void updateUI(){
        ((Group)findActor("button")).findActor("btn_choose_title").setVisible(!isBall);
        penPanel.setVisible(!isBall);
        ballPanel.setVisible(isBall);
    }

    @Override
    protected void initButtons() {
        super.initButtons();
        findActor("button", Touchable.enabled).addListener(new ClickListener() {
            @Override
            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
                isBall = !isBall;
                updateUI();
                return super.touchDown(event, x, y, pointer, button);
            }
        });
        findActor("btn_back", Touchable.enabled).addListener(new ButtonListener() {
            @Override
            public void touchUpEffect() {
                super.touchUpEffect();
                back();
            }
        });
    }
    @Override
    protected boolean back() {
        if (super.back()) {
            end(MenuScreen.class);
            return true;
        } else {
            return false;
        }
    }

}
