package com.zyb.loveball.ui;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.utils.SpriteDrawable;
import com.badlogic.gdx.scenes.scene2d.utils.TextureRegionDrawable;
import com.badlogic.gdx.utils.Align;
import com.zyb.loveball.animations.CommonAnimation;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.assets.Configuration;
import com.zyb.loveball.assets.GoodData;
import com.zyb.loveball.utils.listener.LClickListener;

/**
 * Created by Doodle on 2018/10/17.
 */

public class BallStoreObject extends StoreObject{
    CommonAnimation animation;

    public BallStoreObject(Group root, int id, int type, final StorePanel panel) {
        super(root,id,type,panel);
    }

    protected void changeMask(){
        mask = root.findActor("mask");
        Sprite sprite = Assets.instance.ui.createSprite(data.getResources());
        SpriteDrawable spriteDrawable = new SpriteDrawable(sprite);
        mask.setDrawable(spriteDrawable);

    }

    public void update() {
        super.update();
        if (id == Configuration.settingData.getGoodId(type)) {
            initAnimation();
            animation.setVisible(true);
            mask.setVisible(false);
        } else {
            if(animation!=null) {
                animation.setVisible(false);
            }
            mask.setVisible(true);
        }
    }

    private void initAnimation(){
        if(animation == null){
            animation = new CommonAnimation("animations/"+this.data.getAnimation()+".skel");
            root.addActor(animation);
            animation.setPosition(mask.getX(Align.center),mask.getY(Align.center));
            animation.getState().setAnimation(0, "idle", true);
            animation.setVisible(false);
        }
    }


}
