package com.zyb.loveball.ui;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.zyb.loveball.assets.Assets;

public class Grid extends Actor {
    TextureAtlas.AtlasRegion region;
    TextureAtlas.AtlasRegion bgRegion;
    boolean needBg;
    public Grid(){
        region = new TextureAtlas.AtlasRegion(Assets.instance.ui.findRegion("bg_net"));
        bgRegion = Assets.instance.ui.findRegion("white");
        setSize(480,800);
        setTouchable(Touchable.disabled);
    }

    public void setNeedBg(boolean needBg) {
        this.needBg = needBg;
    }

    @Override
    public void setSize(float width, float height) {
        super.setSize(width, height);
        if(height<800) {
            region.setRegion(region,0, 0, (int) width, (int) height);
        }
        originX = width/2;
        originY = height/2;
    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
        if(needBg){
            batch.setColor(color);
            batch.draw(bgRegion,x,y,originX,originY,width,height,scaleX,scaleY,rotation);
            batch.setColor(Color.WHITE);
        }
        if(height>800) {
            batch.draw(region, x, y, originX, originY, width, 800, scaleX, scaleY, rotation);
            batch.draw(region, x, y + 800);
        }else {
            batch.draw(region, x, y, originX, originY, width, height, scaleX, scaleY, rotation);
        }
    }
}
