package com.zyb.loveball.utils;

import com.badlogic.gdx.Application;
import com.badlogic.gdx.Gdx;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by Doodle on 2018/11/14.
 */

public class FlurryUtils {
    private static FlurryListener listener;

    public static interface FlurryListener {
        public void logEvent(String e, Map<String, String> map);
    }

    private static void f(String k, String v, String e) {
        if (Gdx.app.getType() == Application.ApplicationType.Android) {
            Map<String, String> m = new HashMap<String, String>(1);
            m.put(k, v);
            if (listener != null) {
                listener.logEvent(e, m);
            }
        }
    }

    public static void setLiterer(FlurryListener literer) {
        FlurryUtils.listener = literer;
    }

    private static void Level(String k, String v) {
        f(k, v, "Level");
    }

    private static void Ads(String k, String v) {
        f(k, v, "Ads");
    }

    private static void Challenge(String k, String v) {
        f(k, v, "challenge");
    }

    private static void Skin(String k, String v) {
        f(k, v, "Skin");
    }

    private static void Event(String k, String v) {
        f(k, v, "Event");
    }
    //关卡id（开始，Retry也要计算在内）
    public static void level_Start(int chapter,int id){
        Level("level_Start",chapter+"_"+id);
    }
    //关卡id（第一次通过统计）
    public static void level_FirstWin(int chapter,int id){
        Level("level_FirstWin",chapter+"_"+id);
    }
    //关卡id（胜利）
    public static void level_Win(int chapter,int id){
        Level("level_Win",chapter+"_"+id);
    }
    //关卡id（失败、主动刷新也算）
    public static void level_Fail(int chapter,int id){
        Level("level_Fail",chapter+"_"+id);
    }
    //关卡id（第一次重试次数）
    public static void level_FirstRestart(int chapter,int id){
        Level("level_FirstRestart",chapter+"_"+id);
    }
    //关卡id（第一次继续次数）
    public static void level_Restart(int chapter,int id){
        Level("level_Restart",chapter+"_"+id);
    }
    //关卡id（三星通关）
    public static void level_3Stars(int chapter,int id){
        Level("level_3Stars",chapter+"_"+id);
    }
    //关卡id（关卡跳过）
    public static void level_Skip(int chapter,int id){
        Level("level_Skip",chapter+"_"+id);
    }
    //关卡id（金币提示次数）
    public static void level_HintCoin(int chapter,int id){
        Level("level_HintCoin",chapter+"_"+id);
    }
    //关卡id（广告提示次数）
    public static void level_HintAD(int chapter,int id){
        Level("level_HintAD",chapter+"_"+id);
    }



    public static void Ads_Interstitial(String str){
        Ads("Ads_Interstitial",str);
    }
    public static void Ads_Reward(String str){
        Ads("Ads_Reward",str);
    }
    public static void Ads_Banner(String str){
        Ads("Ads_Banner",str);
    }


    //挑战ID
    public static void Chanllenge_Start(int challenge,int id){
        Challenge("Chanllenge_Start",challenge+"_"+id);
    }
    //挑战ID
    public static void Chanllenge_Win(int challenge,int id){
        Challenge("Chanllenge_Win",challenge+"_"+id);
    }
    //擦除墨迹次数
    public static void Chanllenge_Eraser(int challenge,int id){
        Challenge("Chanllenge_Eraser",challenge+"_"+id);
    }


    //炸弹ID（在商店里点击一次Select记一次）
    public static void Skin_Bomb(int id){
        Skin("Skin_Bomb",id+"");
    }
    //笔ID
    public static void Skin_Pen(int id){
        Skin("Skin_Pen",id+"");
    }


    //Coin10（通关金币打折弹出次数）
    public static void Event_CoinPush(String str){
        Event("Event_CoinPush",str);
    }
    //Coin10（通关金币打折点击次数
    public static void Event_CoinClick(String str){
        Event("Event_CoinClick",str);
    }

//    public static void level


//    //得到过推送的玩家数量统计
//    public static void stage_start(int ) {
//        Stage("stage_start", "");
//    }
//
//    //推送出现的总次数
//    public static void notification_total() {
//        notification("notification", "show_times");
//    }
//
//    //通过推送进入游戏的次数
//    public static void notification_game() {
//        notification("notification", "resume_game_times");
//    }
//
//    //累计得到推送数量的玩家数量分布
//    public static void notification_total_show_times(int num) {
//        notification("total_show_times", num + "");
//    }
//
//    //rate show
//    public static void rate_show(int num) {
//        rate("rate", "show_" + num);
//    }
//
//    //rate click
//    public static void rate_click() {
//        rate("rate", "rated");
//    }
//
//    public static void question_quit(int num) {
//        gameplay("question_quit", "question_quit_" + num);
//    }
//
//    public static void question_fail(int num) {
//        gameplay("question_fail", "question_fail_" + num);
//    }
//
//    public static void behavior(long time) {
//        Date date = new Date(time);
//        SimpleDateFormat format = new SimpleDateFormat("HH:mm");
//        gameplay("behavior", "behavior_" + format.format(date));
//    }
//
//    //累计赢得1~250次比赛胜利个字对应的玩家数量
//    public static void game_win(int num) {
//        gameplay("game_win", "" + num);
//    }
//
//    //点开过booster界面的完结数量
//    public static void booster_interface() {
//        booster("booster_interface", "booster_interface");
//    }
//
//    //通过分享分别累计获得1~250个重生道具的玩家数量
//    public static void revive_invite(int num) {
//        booster("revive_invite", num + "");
//    }
//
//    //在第1~12题分别使用过extra_life的玩家数量
//    public static void revive_question(int questionId) {
//        booster("revive_question", questionId + "");
//    }
//
//    //累计使用过extra_life的玩家数量
//    public static void revive_use() {
//        booster("revive_use", "revive_use");
//    }
//
//    //在第1~12题分别使用过wrong_gone的玩家数量
//    public static void wrong_gone_question(int questionId) {
//        booster("wrong_gone_question", "" + questionId);
//    }
//
//    //累计使用过wrong_gone的玩家数量
//    public static void wrong_gone_use() {
//        booster("wrong_gone_use", "wrong_gone_use");
//    }


//	public static void level_3stars(int id) {
//		Level("level_3stars", "level"+(id+1));
//	}
//	public static void level_retry(int id) {
//		Level("level_re", "level"+(id+1));
//	}
//
//	public static void level_pause(int id) {
//		Level("level_pause", "level"+(id+1));
//	}
//
//	public static void level_unlock(int id){
//		Level("level_unlock","level"+(id+1));
//	}
//
//	public static void Package_buy(){
//		Charge("Package_buy","Package_buy");
//	}
//
//	public static void Coin_buy(String str){
//		Charge("Coin_buy",str);
//	}
//
//	public static void Levelup_fuel_purchase(int carId,int level){
//        Store("Levelup_fuel_purchase","car_" + carId+"_level_"+level);
//	}
//
//
//    public static void Levelup_speed_purchase(int carId,int level){
//        Store("Levelup_speed_purchase","car_" + carId+"_level_"+level);
//    }
//
//    public static void Levelup_turn_purchase(int carId,int level){
//        Store("Levelup_turn_purchase","car_" + carId+"_level_"+level);
//    }
//
//    public static void character_purchase(int id){
//	    Store("Character_purchase","character_"+(id+1));
//    }
//
//    public static void car_purchase(int id){
//	    Store("Car_purchase","car_"+(id+1));
//    }
//
//    public static void LTO_show(){
//        LTO("LTO_show","show");
//    }
//
//    public static void LTO_buy(){
//        LTO("LTO_buy","cost");
//    }
//
//    public static void LTO_success(){
//        LTO("LTO_success","success");
//    }
//
//    public static void LTO_Level(int levelId){
//	    LTO("LTO_Level","LTO_level_"+(levelId+1));
//    }
//
//    public static void More_Game_click(){
//        View("More_Game_click","click");
//    }
//
//    public static void daily_bonus(int dayId){
//	    View("daily_bonus","daily_bonus_"+(dayId+1));
//    }
//
//    public static void Ads_show(){
//	    View("Ads_show","show");
//    }
//
//    public static void newbie(String str){
//	    guide("newbie",str);
//    }

}
