package com.zyb.loveball.utils;

import com.badlogic.gdx.utils.FloatArray;

public class HintUtil {

    public static FloatArray saveHintVertexes(FloatArray vertex, float x, float y) {
        float lastX = vertex.get(0) + x;
        float lastY = vertex.get(1) + y;
        FloatArray preVertexes = new FloatArray();
        int size = vertex.size;
        preVertexes.add(vertex.get(0) + x);
        preVertexes.add(vertex.get(1) + y);
        for (int i = 2; i < vertex.size; i += 2) {
            if (i == vertex.size - 2) {
                preVertexes.add(vertex.get(i) + x);
                preVertexes.add(vertex.get(i + 1) + y);
                continue;
            }
            float offsetX = vertex.get(i) - lastX + x;
            float offsetY = vertex.get(i + 1) - lastY + y;
            float length = (float) Math.sqrt(offsetX * offsetX + offsetY * offsetY);
            if (size >= 8 && i % 8 != 0 && length < 0.1f) continue;
            preVertexes.add(vertex.get(i) + x);
            preVertexes.add(vertex.get(i + 1) + y);
            lastX = vertex.get(i) + x;
            lastY = vertex.get(i + 1) + y;
        }
        return preVertexes;
    }
}
