package com.zyb.loveball.utils;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.zyb.loveball.assets.Assets;
import com.zyb.loveball.constants.Constant;

public class LevelPicUtil {
    public static Sprite getLevelPic(int levelId, TextureAtlas atlas) {
        if (atlas == null) return null;
        String pngFileName = "level_pic_" + levelId;
        FileHandle pngFileHandle = Gdx.files.local(Constant.LEVEL_PIC_PATH + pngFileName + ".png");
        Sprite region = null;
        if (pngFileHandle.exists()) {
            boolean loaded = Assets.instance.assetManagerLocal.isLoaded(Constant.LEVEL_PIC_PATH + pngFileName + ".png");
            if (loaded) {
                Assets.instance.assetManagerLocal.unload(Constant.LEVEL_PIC_PATH + pngFileName + ".png");
            }
            Assets.instance.assetManagerLocal.load(Constant.LEVEL_PIC_PATH + pngFileName + ".png", Texture.class);
            Assets.instance.assetManagerLocal.finishLoading();
            Log.log("LevelPicUtil", "load pic " + pngFileName);
            Texture tmpTexture = Assets.instance.assetManagerLocal.get(Constant.LEVEL_PIC_PATH + pngFileName + ".png");
            if (tmpTexture != null) {
                region = new Sprite(tmpTexture);
            }
        }
        if (region == null) {
            region = atlas.createSprite(pngFileName);
        }
        return region;
    }

    public static void disposeLocalPic(int levelId) {
        String pngFileName = "level_pic_" + levelId;
        boolean loaded = Assets.instance.assetManagerLocal.isLoaded(Constant.LEVEL_PIC_PATH + pngFileName + ".png");
        if (loaded) {
            Assets.instance.assetManagerLocal.unload(Constant.LEVEL_PIC_PATH + pngFileName + ".png");
        }
    }
}
