package com.zyb.loveball.utils;

import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.math.Polygon;

import java.util.*;
import java.util.List;

public class MergePolygon {
    static ArrayList<double[]> polygonA, polygonB, result;
    static List<double[]> polygonAJump, polygonBJump;
    static int mark = 0;


    public static ArrayList mergePolygonPoints(float[] polygon1, float[] polygon2) {
        monitoringPointInt = 0;
        firstRun = true;
        double[][] tmpPolygonA = new double[polygon1.length / 2][2];
        double[][] tmpPolygonB = new double[polygon2.length / 2][2];
        for (int i = 0; i < polygon1.length / 2; i++) {
            tmpPolygonA[i][0] = polygon1[i * 2];
            tmpPolygonA[i][1] = polygon1[i * 2 + 1];
        }
        for (int i = 0; i < polygon2.length / 2; i++) {
            tmpPolygonB[i][0] = polygon2[i * 2];
            tmpPolygonB[i][1] = polygon2[i * 2 + 1];
        }
        polygonA = new ArrayList<>(Arrays.asList(tmpPolygonA));
        polygonB = new ArrayList<>(Arrays.asList(tmpPolygonB));
        polygonAJump = new ArrayList<>();
        polygonBJump = new ArrayList<>();
        result = new ArrayList<>();
        boolean hasHandle = false;
        for (int i = 0; i < polygonA.size() && !hasHandle; i++) {
            for (int j = 0; j < polygonB.size() && !hasHandle; j++) {
                if (samePoint(polygonA.get(i)[0], polygonA.get(i)[1], polygonB.get((j + 1) % polygonB.size())[0], polygonB.get((j + 1) % polygonB.size())[1]) &&
                        samePoint(polygonA.get((i + 1) % polygonA.size())[0], polygonA.get((i + 1) % polygonA.size())[1], polygonB.get(j)[0], polygonB.get(j)[1])) {
                    hasHandle = true;
                    monitoringPointInt = (j + 2) % polygonB.size();
                    while (monitoringPointInt != (j) % polygonB.size()) {
                        i++;
                        if (i / polygonA.size() > 0) {
                            i = i % polygonA.size();
                        }
                        polygonA.add((i) % polygonA.size(), polygonB.get(monitoringPointInt));
                        monitoringPointInt++;
                        monitoringPointInt %= polygonB.size();
                    }
                }
            }
        }
        mark = 0;

        if (hasHandle) {
            return polygonA;
        } else {
//            for(int i=0;i<polygonA.size();i++){
//                System.out.println("polygonA--->"+polygonA.get(i)[0]+"  "+polygonA.get(i)[1]);
//            }
//            for(int i =0;i<polygonB.size();i++){
//                System.out.println("polygonB--->"+polygonB.get(i)[0]+"  "+polygonB.get(i)[1]);
//            }
            mergePolygon();
//            for(int i =0;i<result.size();i++){
//                System.out.println("result--->"+result.get(i)[0]+"  "+result.get(i)[1]);
//            }
//            System.out.println(result.size());
            return result;
        }
    }


    public static boolean samePoint(double x1, double y1, double x2, double y2) {
        double offsetX = Math.abs(x2 - x1);
        double offsetY = Math.abs(y2 - y1);
        if (offsetX <= 0.00001F && offsetY < 0.00001F) return true;
        return false;
    }

    ;

    static int monitoringPointInt = 0;

    private static void mergePolygon() {
        //获得跳转数组
        for (int i = 0; i < polygonA.size(); i++) {
            double x1 = polygonA.get((i + polygonA.size() - 1) % polygonA.size())[0];
            double y1 = polygonA.get((i + polygonA.size() - 1) % polygonA.size())[1];
            double x2 = polygonA.get(i)[0];
            double y2 = polygonA.get(i)[1];
            for (int j = 0; j < polygonB.size(); j++) {
                double x3 = polygonB.get((j + polygonB.size() - 1) % polygonB.size())[0];
                double y3 = polygonB.get((j + polygonB.size() - 1) % polygonB.size())[1];
                double x4 = polygonB.get(j)[0];
                double y4 = polygonB.get(j)[1];
                if (!MathUtil.linesIntersect(x1, y1, x2, y2, x3, y3, x4, y4)) continue;
//                double x, y;
                if ((x2 - x1) * (y4 - y3) - (x4 - x3) * (y2 - y1) == 0) {     //向量共线
                    continue;
                } else {
                    Vector2 vector2 = crossPoint(x1, y1, x2, y2, x3, y3, x4, y4);
                    double x = vector2.x;
                    double y = vector2.y;
                    if ((x == x1 && y == y1) || (x == x2 && y == y2) || (x == x4 && y == y4) || (x == x3 && y == y3)) {     //焦点为端点不算相交
                        continue;
                    }
                    polygonAJump.add(new double[]{x, y, (i - 1 + polygonA.size() ) % polygonA.size(), j});     //polygonA的跳转数组{焦点x，焦点y，polygonA的跳转点，polygonB的目标点}
                    polygonBJump.add(new double[]{x, y, i, (j - 1 + polygonB.size() ) % polygonB.size()});     //polygonB的跳转数组{焦点x，焦点y，polygonB的跳转点，polygonA的目标点}
                }
            }
        }
        //合并polygon
        ArrayList<Float> floatArrayList = new ArrayList<>();
        for (int i = 0; i < polygonB.size(); i++) {
            floatArrayList.add((float) polygonB.get(i)[0]);
            floatArrayList.add((float) polygonB.get(i)[1]);
        }
        float[] floats = new float[floatArrayList.size()];
        for (int i = 0; i < floatArrayList.size(); i++) {
            floats[i] = floatArrayList.get(i);
        }
        Polygon polygon = new Polygon(floats);
        while (true) {
            if (polygon.contains((float) polygonA.get(monitoringPointInt)[0], (float) polygonA.get(monitoringPointInt)[1])) {
                monitoringPointInt++;
            } else break;
        }
        runA(monitoringPointInt);


    }

    public static boolean firstRun = true;



    private static void runA(double begin) {
        mark ++;
        if(mark > 200) return;
        for (int i = (int) begin; ; i++) {
            if (i >= polygonA.size()) i = 0;
            if (i == monitoringPointInt && !firstRun) return;
            firstRun = false;
            result.add(polygonA.get(i));
            //可能出现在一条线段上有多个焦点的情况，arrayList用于记录焦点位置以及距离初始点距离
            ArrayList<Double> arrayList = new ArrayList<>();
            for (int j = 0; j < polygonAJump.size(); j++) {
                if (polygonAJump.get(j)[2] == i) {
                    arrayList.add((double) j);
                    double x = polygonAJump.get(j)[0] - polygonA.get(i)[0];
                    double y = polygonAJump.get(j)[1] - polygonA.get(i)[1];
                    arrayList.add(Math.sqrt(x * x + y * y));
                }
            }
            int resInt = -1;
            double minDistance = Double.MAX_EXPONENT;
            for (int j = 0; j < arrayList.size(); j = j + 2) {
                if (arrayList.get(j + 1) < minDistance) {
                    minDistance = arrayList.get(j + 1);
                    resInt = (int) (double) arrayList.get(j);
                }
            }
            if (resInt != -1) {
                result.add(new double[]{polygonAJump.get(resInt)[0], polygonAJump.get(resInt)[1]});
                runB(polygonAJump.get(resInt)[3]);
                return;
            }

        }
    }

    private static void runB(double begin) {
        mark ++;
        if(mark > 200) return;
        for (int i = (int) begin; ; i++) {
            if (i >= polygonB.size()) i = 0;
            result.add(polygonB.get(i));
            ArrayList<Double> arrayList = new ArrayList<>();
            for (int j = 0; j < polygonBJump.size(); j++) {
                if (polygonBJump.get(j)[3] == i) {
                    arrayList.add((double) j);
                    double x = polygonBJump.get(j)[0] - polygonB.get(i)[0];
                    double y = polygonBJump.get(j)[1] - polygonB.get(i)[1];
                    arrayList.add(Math.sqrt(x * x + y * y));
                }
            }
            int resInt = -1;
            double min = Double.MAX_EXPONENT;
            for (int j = 0; j < arrayList.size(); j = j + 2) {
                if (arrayList.get(j + 1) < min) {
                    min = arrayList.get(j + 1);
                    resInt = (int) (double) arrayList.get(j);
                }
            }
            if (resInt != -1) {
                result.add(new double[]{polygonBJump.get(resInt)[0], polygonBJump.get(resInt)[1]});
                runA(polygonBJump.get(resInt)[2]);
                return;
            }

        }
    }

    // 计算两直线的交点x坐标
    private static Vector2 crossPoint(double x1, double y1, double x2, double y2,
                                      double x3, double y3, double x4, double y4) {

        double x = ((x1 - x2) * (x3 * y4 - x4 * y3) - (x3 - x4) * (x1 * y2 - x2 * y1))
                / ((x3 - x4) * (y1 - y2) - (x1 - x2) * (y3 - y4));

        double y = ((y1 - y2) * (x3 * y4 - x4 * y3) - (x1 * y2 - x2 * y1) * (y3 - y4))
                / ((y1 - y2) * (x3 - x4) - (x1 - x2) * (y3 - y4));

//        System.out.println("他们的交点为: (" + x + "," + y + ")");

        return new Vector2((float) x, (float) y);
    }


}