package com.zyb.loveball.utils.listener;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Event;
import com.badlogic.gdx.scenes.scene2d.InputEvent;

/**
 * Created by lilexiang on 17-2-14.
 */
public class ButtonListener extends LClickListener {
    float scaleOriginX;
    float scaleOriginY;
    private Actor activeActor;

    public ButtonListener() {
        super();
    }

    public ButtonListener(Actor actor) {
        this.activeActor = actor;
    }

    protected void touched(InputEvent event) {
        isTouched = true;
        if (activeActor != null) {
            scaleOriginX = activeActor.getScaleX();
            scaleOriginY = activeActor.getScaleY();
            activeActor.setScale(scaleOriginX * 0.95F, scaleOriginY * 0.95F);
        } else {
            scaleOriginX = event.getListenerActor().getScaleX();
            scaleOriginY = event.getListenerActor().getScaleY();
            event.getListenerActor().setScale(scaleOriginX * 0.95F, scaleOriginY * 0.95F);
        }
    }


    public void release(Event event) {
        if (!isTouched) return;
        if (activeActor != null) {
            activeActor.setScale(scaleOriginX, scaleOriginY);
        } else {
            event.getListenerActor().setScale(scaleOriginX, scaleOriginY);
        }
        isTouched = false;
    }


}