package com.zyb.loveball.utils.listener;

import com.badlogic.gdx.scenes.scene2d.Event;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;

public class LClickListener extends ClickListener {
    protected boolean isTouched;
    @Override
    public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
        if(pointer>0) return false;
        if (isTouched) return false;
        if (!isTouched) {
            touched(event);
            touchDownEffect();
            return true;
        } else {
            return false;
        }
    }

    @Override
    public void touchDragged(InputEvent event, float x, float y, int pointer) {
        if(pointer>0) return;
        super.touchDragged(event, x, y, pointer);
        if (event.getTarget().hit(x, y, true) == null) {
            release(event);
        }
    }

    @Override
    public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
        if(pointer>0) return;
        super.touchUp(event, x, y, pointer, button);
        if(isTouched) {
            touchUpEffect();
        }
        release(event);
    }

    protected void touched(InputEvent event) {
        isTouched = true;
    }

    public void touchUpEffect(){

    }

    public void touchDownEffect(){

    }

    public void release(Event event) {
        if (!isTouched) return;
        isTouched = false;
    }


    public boolean isTouched() {
        return isTouched;
    }
}
